/* SCCS @(#)BPError.mod	1.1---02/23/00--13:19:17 */

/* Copyright 1999 University of Southern California Brain Lab */
/* email nsl@java.usc.edu */

nslImport nslAllImports;

nslModule BPError (int outSize) 
{
    public NslDinFloat1 yo(outSize);      
    public NslDinFloat1 t(outSize);  
    
    public NslDoutFloat1 err(outSize);      

    private NslFloat0 epsilon();      
    public  NslFloat0 tss();
        
    public void initTrain() {
        tss = 0.0;
    }

    public void simTrain() {
        err = yo - t;
        tss = tss + nslSum(err ^ err);
    }

    public void endTrain() {
        if (tss < epsilon) {
            nslPrintln("Convergence");
	    verbatim_NSLJ;
            system.getScheduler().breakCycles();
	    system.continueCmd();
	    verbatim_off;
        }
    }
}


